<template>
  <div id="gameCont"></div>
</template>

<script>
import Phaser from "phaser";
import Preload from "../lib/scenes/Preload.js";
import PlayScene from "../lib/scenes/PlayScene";
import { Menu } from "../lib/scenes/Menu";
import { LevelsScene } from "../lib/scenes/LevelsScene";

export default {
  data() {
    return {
      containerId: `gameCont`,
      game: null
    };
  },
  mounted() {
    const MAP_WIDTH = 1600;
    const { offsetWidth } = this.$el;
    const mapOffset = MAP_WIDTH > offsetWidth ? MAP_WIDTH - offsetWidth : 0;
    const width = MAP_WIDTH > offsetWidth ? offsetWidth : MAP_WIDTH;
    const HEIGHT = 640;
    const ZOOM_FACTOR = 2;

    const SHARED_CONFIG = {
      mapOffset,
      width,
      height: HEIGHT,
      zoomFactor: ZOOM_FACTOR,
      leftTopCorner: {
        x: (width - width / ZOOM_FACTOR) / 2,
        y: (HEIGHT - HEIGHT / ZOOM_FACTOR) / 2
      },
      rightTopCorner: {
        x: width / ZOOM_FACTOR + (width - width / ZOOM_FACTOR) / 2,
        y: (HEIGHT - HEIGHT / ZOOM_FACTOR) / 2
      },
      rightBottomCorner: {
        x: width / ZOOM_FACTOR + (width - width / ZOOM_FACTOR) / 2,
        y: HEIGHT / ZOOM_FACTOR + (HEIGHT - HEIGHT / ZOOM_FACTOR) / 2
      },
      maxLevel: 9
    };

    // Inicjowanie wszystkich scen
    // Menu musi być ostatnie aby użyć scene.launch
    const scenes = [Preload, PlayScene, Menu, LevelsScene];
    const createScene = Scene => new Scene(SHARED_CONFIG);
    const initScenes = () => scenes.map(createScene);

    const config = {
      parent: `gameCont`,
      ...SHARED_CONFIG,
      backgroundColor: 0x000000,
      pixelArt: true,
      scene: initScenes(),
      physics: {
        default: `arcade`,
        arcade: {
          debug: false
        }
      }
    };
    // eslint-disable-next-line no-unused-vars
    this.game = new Phaser.Game(config);
  }
};
</script>
